From db7092824ad3ca532104e71b76390aabf8c3a207 Mon Sep 17 00:00:00 2001
From: Alexandra Wang <alexandra.wang.oss@gmail.com>
Date: Tue, 20 Jan 2026 09:59:35 -0800
Subject: [PATCH v1 1/2] Extend CREATE STATISTICS syntax for join MCV
 statistics

This patch extends CREATE STATISTICS to support creating join MCV
statistics using a JOIN clause.

Proposed syntax:

  CREATE STATISTICS stat_name (mcv)
  ON other_table.filter_col
  FROM primary_table JOIN other_table ON (primary_table.fk = other_table.pk);

Join MCV statistics capture the joint distribution of filter column
values and their frequencies in the primary (referencing) table. This
enables improved cardinality estimation for queries with selective
filters on joined tables.

In order to store the join mcv stats in the cataloag, The following
changes are made in pg_statistic_ext and pg_statistic_ext_data:

- Add new kind 'c' as an option of stxkind
- Add stxotherrel (oid) and stxjoinkeys (int2vector) fields to
  pg_statistic_ext
- Use the existing stxkeys (int2vector) to store the filter attributes
  of stxortherrel
- Create pg_statistic_ext_otherrel_index on (stxrelid, stxotherrel)
- Add stxdjoinmcv (pg_join_mcv_list) to pg_statistic_ext_data

Pattern detection (join + filter combinations) are added in the
following planner functions to calculate join mcv selectivity:

- clauselist_selectivity_ext()
- get_foreign_key_join_selectivity()

Current scope and limitations:

- Consider only joins on 2 tables
- Consider only one pair of equality join clause, but can be extended to multiple easily
- Filter clause support only Equality and IN operators for now
- Consider only Vars, not considering Expressions yet
- Mainly looked at inner join, but semi/anti/full shouldn't be too difficult
---
 src/backend/commands/statscmds.c              |  457 +++--
 src/backend/optimizer/path/clausesel.c        |   43 +-
 src/backend/optimizer/path/costsize.c         |   57 +-
 src/backend/parser/gram.y                     |    7 +
 src/backend/parser/parse_utilcmd.c            |  128 +-
 src/backend/statistics/Makefile               |    1 +
 src/backend/statistics/extended_stats.c       |  238 ++-
 src/backend/statistics/extended_stats_funcs.c |    1 +
 src/backend/statistics/join_mcv.c             | 1493 +++++++++++++++++
 src/backend/statistics/meson.build            |    1 +
 src/backend/tcop/utility.c                    |   52 +-
 src/include/catalog/catversion.h              |    2 +-
 src/include/catalog/pg_proc.dat               |   20 +
 src/include/catalog/pg_statistic_ext.h        |    8 +
 src/include/catalog/pg_statistic_ext_data.h   |    1 +
 src/include/catalog/pg_type.dat               |    7 +
 .../statistics/extended_stats_internal.h      |   13 +-
 src/include/statistics/statistics.h           |   84 +
 src/test/regress/expected/oidjoins.out        |   13 +
 src/test/regress/expected/stats_ext.out       |   14 +-
 .../regress/expected/stats_ext_crossrel.out   |  288 ++++
 src/test/regress/expected/type_sanity.out     |   10 +-
 src/test/regress/parallel_schedule            |    3 +
 src/test/regress/sql/oidjoins.sql             |   12 +
 src/test/regress/sql/stats_ext_crossrel.sql   |  172 ++
 25 files changed, 2943 insertions(+), 182 deletions(-)
 create mode 100644 src/backend/statistics/join_mcv.c
 create mode 100644 src/test/regress/expected/stats_ext_crossrel.out
 create mode 100644 src/test/regress/sql/stats_ext_crossrel.sql

diff --git a/src/backend/commands/statscmds.c b/src/backend/commands/statscmds.c
index c1da79f36ba..529293576d0 100644
--- a/src/backend/commands/statscmds.c
+++ b/src/backend/commands/statscmds.c
@@ -43,6 +43,9 @@
 static char *ChooseExtendedStatisticName(const char *name1, const char *name2,
 										 const char *label, Oid namespaceid);
 static char *ChooseExtendedStatisticNameAddition(List *exprs);
+static bool extract_join_columns(JoinExpr *join, int stxkeys_varno,
+								 Oid *relid, Oid *other_relid,
+								 int16 *jk_attnums);
 
 
 /* qsort comparator for the attnums in CreateStatistics */
@@ -78,7 +81,7 @@ CreateStatistics(CreateStatsStmt *stmt, bool check_rights)
 	Datum		exprsDatum;
 	Relation	statrel;
 	Relation	rel = NULL;
-	Oid			relid;
+	Oid			relid = InvalidOid;
 	ObjectAddress parentobject,
 				myself;
 	Datum		types[4];		/* one for each possible type of statistic */
@@ -92,29 +95,30 @@ CreateStatistics(CreateStatsStmt *stmt, bool check_rights)
 	int			i;
 	ListCell   *cell;
 	ListCell   *cell2;
+	Node	   *rln;
+	JoinExpr   *join = NULL;
+	Relation	other_rel = NULL;
+	Oid			other_relid = InvalidOid;
+	int16		jk_attnums[2];	/* Join key attribute numbers: [rel's jk
+								 * attnum1, other_rel's jk attnum2] */
+	int			stxkeys_varno = 0;	/* For joins: which table has the
+									 * statistics columns */
 
 	Assert(IsA(stmt, CreateStatsStmt));
 
 	/*
-	 * Examine the FROM clause.  Currently, we only allow it to be a single
-	 * simple table, but later we'll probably allow multiple tables and JOIN
-	 * syntax.  The grammar is already prepared for that, so we have to check
-	 * here that what we got is what we can support.
+	 * Examine the FROM clause. We support either: 1. Single RangeVar for
+	 * single-table statistics 2. JoinExpr for join statistics
 	 */
 	if (list_length(stmt->relations) != 1)
 		ereport(ERROR,
 				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
-				 errmsg("only a single relation is allowed in CREATE STATISTICS")));
-
-	foreach(cell, stmt->relations)
-	{
-		Node	   *rln = (Node *) lfirst(cell);
+				 errmsg("only a single relation or JOIN is allowed in CREATE STATISTICS")));
 
-		if (!IsA(rln, RangeVar))
-			ereport(ERROR,
-					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
-					 errmsg("only a single relation is allowed in CREATE STATISTICS")));
+	rln = (Node *) linitial(stmt->relations);
 
+	if (IsA(rln, RangeVar))
+	{
 		/*
 		 * CREATE STATISTICS will influence future execution plans but does
 		 * not interfere with currently executing plans.  So it should be
@@ -152,69 +156,19 @@ CreateStatistics(CreateStatsStmt *stmt, bool check_rights)
 					(errcode(ERRCODE_INSUFFICIENT_PRIVILEGE),
 					 errmsg("permission denied: \"%s\" is a system catalog",
 							RelationGetRelationName(rel))));
-	}
-
-	Assert(rel);
-	relid = RelationGetRelid(rel);
 
-	/*
-	 * If the node has a name, split it up and determine creation namespace.
-	 * If not, put the object in the same namespace as the relation, and cons
-	 * up a name for it.  (This can happen either via "CREATE STATISTICS ..."
-	 * or via "CREATE TABLE ... (LIKE)".)
-	 */
-	if (stmt->defnames)
-		namespaceId = QualifiedNameGetCreationNamespace(stmt->defnames,
-														&namestr);
-	else
-	{
-		namespaceId = RelationGetNamespace(rel);
-		namestr = ChooseExtendedStatisticName(RelationGetRelationName(rel),
-											  ChooseExtendedStatisticNameAddition(stmt->exprs),
-											  "stat",
-											  namespaceId);
+		relid = RelationGetRelid(rel);
 	}
-	namestrcpy(&stxname, namestr);
-
-	/*
-	 * Check we have creation rights in target namespace.  Skip check if
-	 * caller doesn't want it.
-	 */
-	if (check_rights)
+	else if (IsA(rln, JoinExpr))
 	{
-		AclResult	aclresult;
-
-		aclresult = object_aclcheck(NamespaceRelationId, namespaceId,
-									GetUserId(), ACL_CREATE);
-		if (aclresult != ACLCHECK_OK)
-			aclcheck_error(aclresult, OBJECT_SCHEMA,
-						   get_namespace_name(namespaceId));
+		Assert(stmt->transformed);
+		join = (JoinExpr *) rln;
 	}
-
-	/*
-	 * Deal with the possibility that the statistics object already exists.
-	 */
-	if (SearchSysCacheExists2(STATEXTNAMENSP,
-							  CStringGetDatum(namestr),
-							  ObjectIdGetDatum(namespaceId)))
+	else
 	{
-		if (stmt->if_not_exists)
-		{
-			/*
-			 * Since stats objects aren't members of extensions (see comments
-			 * below), no need for checkMembershipInCurrentExtension here.
-			 */
-			ereport(NOTICE,
-					(errcode(ERRCODE_DUPLICATE_OBJECT),
-					 errmsg("statistics object \"%s\" already exists, skipping",
-							namestr)));
-			relation_close(rel, NoLock);
-			return InvalidObjectAddress;
-		}
-
 		ereport(ERROR,
-				(errcode(ERRCODE_DUPLICATE_OBJECT),
-				 errmsg("statistics object \"%s\" already exists", namestr)));
+				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
+				 errmsg("only a single relation or JOIN is allowed in CREATE STATISTICS")));
 	}
 
 	/*
@@ -252,6 +206,12 @@ CreateStatistics(CreateStatsStmt *stmt, bool check_rights)
 			Form_pg_attribute attForm;
 			TypeCacheEntry *type;
 
+			/* Join stats require table-qualified column names */
+			if (join)
+				ereport(ERROR,
+						(errcode(ERRCODE_INVALID_COLUMN_REFERENCE),
+						 errmsg("join statistics require table-qualified column names")));
+
 			attname = selem->name;
 
 			atttuple = SearchSysCacheAttName(relid, attname);
@@ -290,6 +250,7 @@ CreateStatistics(CreateStatsStmt *stmt, bool check_rights)
 		{
 			Var		   *var = (Var *) selem->expr;
 			TypeCacheEntry *type;
+			Oid			var_relid;
 
 			/* Disallow use of system attributes in extended stats */
 			if (var->varattno <= 0)
@@ -297,22 +258,48 @@ CreateStatistics(CreateStatsStmt *stmt, bool check_rights)
 						(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
 						 errmsg("statistics creation on system columns is not supported")));
 
-			/* Disallow use of virtual generated columns in extended stats */
-			if (get_attgenerated(relid, var->varattno) == ATTRIBUTE_GENERATED_VIRTUAL)
-				ereport(ERROR,
-						(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
-						 errmsg("statistics creation on virtual generated columns is not supported")));
+			/*
+			 * For join stats, track which table the stats objects are from.
+			 * Currently only supports one table (other_rel).
+			 */
+			if (join)
+			{
+				/* Track which table has the statistics columns */
+				if (stxkeys_varno == 0)
+					stxkeys_varno = var->varno;
+				else if (stxkeys_varno != var->varno)
+					ereport(ERROR,
+							(errcode(ERRCODE_INVALID_COLUMN_REFERENCE),
+							 errmsg("join statistics columns from different tables are not supported")));
+
+				/*
+				 * For joins, we'll validate the column after extracting join
+				 * info and determining which table is which.
+				 */
+				attnums[nattnums] = var->varattno;
+				nattnums++;
+			}
+			else
+			{
+				var_relid = relid;
 
-			/* Disallow data types without a less-than operator */
-			type = lookup_type_cache(var->vartype, TYPECACHE_LT_OPR);
-			if (type->lt_opr == InvalidOid)
-				ereport(ERROR,
-						(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
-						 errmsg("column \"%s\" cannot be used in statistics because its type %s has no default btree operator class",
-								get_attname(relid, var->varattno, false), format_type_be(var->vartype))));
+				/* Disallow use of virtual generated columns in extended stats */
+				if (get_attgenerated(var_relid, var->varattno) == ATTRIBUTE_GENERATED_VIRTUAL)
+					ereport(ERROR,
+							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
+							 errmsg("statistics creation on virtual generated columns is not supported")));
 
-			attnums[nattnums] = var->varattno;
-			nattnums++;
+				/* Disallow data types without a less-than operator */
+				type = lookup_type_cache(var->vartype, TYPECACHE_LT_OPR);
+				if (type->lt_opr == InvalidOid)
+					ereport(ERROR,
+							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
+							 errmsg("column \"%s\" cannot be used in statistics because its type %s has no default btree operator class",
+									get_attname(var_relid, var->varattno, false), format_type_be(var->vartype))));
+
+				attnums[nattnums] = var->varattno;
+				nattnums++;
+			}
 		}
 		else					/* expression */
 		{
@@ -324,6 +311,12 @@ CreateStatistics(CreateStatsStmt *stmt, bool check_rights)
 
 			Assert(expr != NULL);
 
+			/* Join stats only support simple column references */
+			if (join)
+				ereport(ERROR,
+						(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
+						 errmsg("expressions are not supported in join statistics")));
+
 			pull_varattnos(expr, 1, &attnums);
 
 			k = -1;
@@ -366,6 +359,111 @@ CreateStatistics(CreateStatsStmt *stmt, bool check_rights)
 		}
 	}
 
+	/*
+	 * For join statistics, now that we know which table has the statistics
+	 * columns, extract the join information.
+	 */
+	if (join)
+	{
+		Assert(stxkeys_varno != 0);
+
+		if (!extract_join_columns(join, stxkeys_varno,
+								  &relid, &other_relid,
+								  jk_attnums))
+			ereport(ERROR,
+					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
+					 errmsg("join statistics require a simple equijoin condition")));
+
+		/* Open both relations now for uniform access later */
+		rel = relation_open(relid, NoLock);
+		other_rel = relation_open(other_relid, NoLock);
+
+		/*
+		 * Validate statistics columns now that we know which tables they're
+		 * from
+		 */
+		for (i = 0; i < nattnums; i++)
+		{
+			TypeCacheEntry *type;
+			Oid			atttype;
+
+			if (get_attgenerated(other_relid, attnums[i]) == ATTRIBUTE_GENERATED_VIRTUAL)
+				ereport(ERROR,
+						(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
+						 errmsg("statistics creation on virtual generated columns is not supported")));
+
+			/* Disallow data types without a less-than operator */
+			atttype = get_atttype(other_relid, attnums[i]);
+			type = lookup_type_cache(atttype, TYPECACHE_LT_OPR);
+			if (type->lt_opr == InvalidOid)
+				ereport(ERROR,
+						(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
+						 errmsg("column \"%s\" cannot be used in statistics because its type %s has no default btree operator class",
+								get_attname(other_relid, attnums[i], false),
+								format_type_be(atttype))));
+		}
+	}
+
+	/*
+	 * Now determine namespace and name. Use rel (primary table for joins).
+	 */
+	if (stmt->defnames)
+		namespaceId = QualifiedNameGetCreationNamespace(stmt->defnames,
+														&namestr);
+	else
+	{
+		namespaceId = RelationGetNamespace(rel);
+		namestr = ChooseExtendedStatisticName(RelationGetRelationName(rel),
+											  ChooseExtendedStatisticNameAddition(stmt->exprs),
+											  "stat",
+											  namespaceId);
+	}
+	namestrcpy(&stxname, namestr);
+
+	/*
+	 * Check we have creation rights in target namespace.  Skip check if
+	 * caller doesn't want it.
+	 */
+	if (check_rights)
+	{
+		AclResult	aclresult;
+
+		aclresult = object_aclcheck(NamespaceRelationId, namespaceId,
+									GetUserId(), ACL_CREATE);
+		if (aclresult != ACLCHECK_OK)
+			aclcheck_error(aclresult, OBJECT_SCHEMA,
+						   get_namespace_name(namespaceId));
+	}
+
+	/*
+	 * Deal with the possibility that the statistics object already exists.
+	 */
+	if (SearchSysCacheExists2(STATEXTNAMENSP,
+							  CStringGetDatum(namestr),
+							  ObjectIdGetDatum(namespaceId)))
+	{
+		if (stmt->if_not_exists)
+		{
+			/*
+			 * Since stats objects aren't members of extensions (see comments
+			 * below), no need for checkMembershipInCurrentExtension here.
+			 */
+			ereport(NOTICE,
+					(errcode(ERRCODE_DUPLICATE_OBJECT),
+					 errmsg("statistics object \"%s\" already exists, skipping",
+							namestr)));
+			/* Close relations */
+			relation_close(rel, NoLock);
+			if (other_rel)
+				relation_close(other_rel, NoLock);
+			return InvalidObjectAddress;
+		}
+
+		ereport(ERROR,
+				(errcode(ERRCODE_DUPLICATE_OBJECT),
+				 errmsg("statistics object \"%s\" already exists", namestr)));
+	}
+
 	/*
 	 * Parse the statistics kinds.
 	 *
@@ -431,13 +529,24 @@ CreateStatistics(CreateStatsStmt *stmt, bool check_rights)
 	build_expressions = (stxexprs != NIL);
 
 	/*
-	 * Check that at least two columns were specified in the statement, or
-	 * that we're building statistics on a single expression.
+	 * Check column count requirements.
 	 */
-	if ((numcols < 2) && (list_length(stxexprs) != 1))
-		ereport(ERROR,
-				(errcode(ERRCODE_INVALID_OBJECT_DEFINITION),
-				 errmsg("extended statistics require at least 2 columns")));
+	if (join)
+	{
+		/* Join stats need at least 1 column (join adds implicit correlation) */
+		if (numcols < 1)
+			ereport(ERROR,
+					(errcode(ERRCODE_INVALID_OBJECT_DEFINITION),
+					 errmsg("extended join statistics require at least one column")));
+	}
+	else
+	{
+		/* Single-table stats need at least 2 columns or 1 expression */
+		if (numcols < 2 && list_length(stxexprs) != 1)
+			ereport(ERROR,
+					(errcode(ERRCODE_INVALID_OBJECT_DEFINITION),
+					 errmsg("extended statistics require at least 2 columns")));
+	}
 
 	/*
 	 * Sort the attnums, which makes detecting duplicates somewhat easier, and
@@ -496,14 +605,23 @@ CreateStatistics(CreateStatsStmt *stmt, bool check_rights)
 	/* Form an int2vector representation of the sorted column list */
 	stxkeys = buildint2vector(attnums, nattnums);
 
-	/* construct the char array of enabled statistic types */
+	/*
+	 * Construct the char array of enabled statistic types. For join
+	 * statistics, only MCV is supported (as STATS_EXT_JOIN_MCV).
+	 */
+	if (join && (build_ndistinct || build_dependencies || build_expressions))
+		ereport(ERROR,
+				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
+				 errmsg("only MCV statistics are supported for join statistics"),
+				 errhint("ndistinct, dependencies, and expression statistics require a single table.")));
+
 	ntypes = 0;
 	if (build_ndistinct)
 		types[ntypes++] = CharGetDatum(STATS_EXT_NDISTINCT);
 	if (build_dependencies)
 		types[ntypes++] = CharGetDatum(STATS_EXT_DEPENDENCIES);
 	if (build_mcv)
-		types[ntypes++] = CharGetDatum(STATS_EXT_MCV);
+		types[ntypes++] = CharGetDatum(other_rel ? STATS_EXT_JOIN_MCV : STATS_EXT_MCV);
 	if (build_expressions)
 		types[ntypes++] = CharGetDatum(STATS_EXT_EXPRESSIONS);
 	Assert(ntypes > 0 && ntypes <= lengthof(types));
@@ -544,6 +662,30 @@ CreateStatistics(CreateStatsStmt *stmt, bool check_rights)
 	if (exprsDatum == (Datum) 0)
 		nulls[Anum_pg_statistic_ext_stxexprs - 1] = true;
 
+	/*
+	 * For join statistics, populate stxotherrel and stxjoinkeys. For
+	 * single-table statistics, these fields are NULL.
+	 */
+	if (join)
+	{
+		int2vector *stxjoinkeys;
+
+		/*
+		 * Build the join keys vector from jk_attnums: [primary_attnum,
+		 * other_attnum]
+		 */
+		stxjoinkeys = buildint2vector(jk_attnums, 2);
+
+		values[Anum_pg_statistic_ext_stxotherrel - 1] = ObjectIdGetDatum(other_relid);
+		values[Anum_pg_statistic_ext_stxjoinkeys - 1] = PointerGetDatum(stxjoinkeys);
+	}
+	else
+	{
+		/* Cross-table fields are NULL for single-table statistics */
+		nulls[Anum_pg_statistic_ext_stxotherrel - 1] = true;
+		nulls[Anum_pg_statistic_ext_stxjoinkeys - 1] = true;
+	}
+
 	/* insert it into pg_statistic_ext */
 	htup = heap_form_tuple(statrel->rd_att, values, nulls);
 	CatalogTupleInsert(statrel, htup);
@@ -560,11 +702,17 @@ CreateStatistics(CreateStatsStmt *stmt, bool check_rights)
 	InvokeObjectPostCreateHook(StatisticExtRelationId, statoid, 0);
 
 	/*
-	 * Invalidate relcache so that others see the new statistics object.
+	 * Invalidate relcache so that others see the new statistics object. For
+	 * join stats, invalidate both tables.
 	 */
 	CacheInvalidateRelcache(rel);
+	if (other_rel)
+		CacheInvalidateRelcache(other_rel);
 
+	/* Close relations */
 	relation_close(rel, NoLock);
+	if (other_rel)
+		relation_close(other_rel, NoLock);
 
 	/*
 	 * Add an AUTO dependency on each column used in the stats, so that the
@@ -575,7 +723,21 @@ CreateStatistics(CreateStatsStmt *stmt, bool check_rights)
 	/* add dependencies for plain column references */
 	for (i = 0; i < nattnums; i++)
 	{
-		ObjectAddressSubSet(parentobject, RelationRelationId, relid, attnums[i]);
+		Oid			col_relid = other_rel ? other_relid : relid;
+
+		ObjectAddressSubSet(parentobject, RelationRelationId, col_relid, attnums[i]);
+		recordDependencyOn(&myself, &parentobject, DEPENDENCY_AUTO);
+	}
+
+	/* For join stats, also add dependencies on join columns */
+	if (other_rel)
+	{
+		ObjectAddressSubSet(parentobject, RelationRelationId,
+							relid, jk_attnums[0]);
+		recordDependencyOn(&myself, &parentobject, DEPENDENCY_AUTO);
+
+		ObjectAddressSubSet(parentobject, RelationRelationId,
+							other_relid, jk_attnums[1]);
 		recordDependencyOn(&myself, &parentobject, DEPENDENCY_AUTO);
 	}
 
@@ -589,8 +751,11 @@ CreateStatistics(CreateStatsStmt *stmt, bool check_rights)
 	 * XXX We intentionally don't consider the expressions before adding this
 	 * dependency, because recordDependencyOnSingleRelExpr may not create any
 	 * dependencies for whole-row Vars.
+	 *
+	 * Join stats are excluded because they span two tables (no single "whole
+	 * table" exists).
 	 */
-	if (!nattnums)
+	if (!join && !nattnums)
 	{
 		ObjectAddressSet(parentobject, RelationRelationId, relid);
 		recordDependencyOn(&myself, &parentobject, DEPENDENCY_AUTO);
@@ -930,6 +1095,106 @@ ChooseExtendedStatisticNameAddition(List *exprs)
 	return pstrdup(buf);
 }
 
+/*
+ * extract_join_columns
+ *
+ * Extract join column information from a JoinExpr for join statistics.
+ * Uses stxkeys_varno to determine which table has the statistics columns (currently
+ * this must be the "other" table, not the "primary" table).
+ *
+ * Populates jk_attnums array with join key attribute numbers: [rel's jk, other_rel's jk]
+ *
+ * Returns true if successful, false if the join condition is too complex.
+ *
+ * Currently, supports only simple equijoin: table1.col1 = table2.col2
+ */
+static bool
+extract_join_columns(JoinExpr *join, int stxkeys_varno,
+					 Oid *relid, Oid *other_relid,
+					 int16 *jk_attnums)
+{
+	Oid			left_relid;
+	Oid			right_relid;
+	Node	   *quals;
+	OpExpr	   *opexpr;
+	Var		   *left_var;
+	Var		   *right_var;
+	AttrNumber	left_attnum;
+	AttrNumber	right_attnum;
+
+	if (!IsA(join->larg, RangeVar) || !IsA(join->rarg, RangeVar))
+		return false;
+
+	left_relid = RangeVarGetRelid((RangeVar *) join->larg, NoLock, false);
+	right_relid = RangeVarGetRelid((RangeVar *) join->rarg, NoLock, false);
+
+	quals = join->quals;
+	if (quals == NULL || !IsA(quals, OpExpr))
+		return false;
+
+	opexpr = (OpExpr *) quals;
+
+	/*
+	 * Must be a binary operator (simple equality join) and both operands must
+	 * be column references
+	 */
+	if (list_length(opexpr->args) != 2 ||
+		!IsA(linitial(opexpr->args), Var) || !IsA(lsecond(opexpr->args), Var))
+		return false;
+
+	left_var = (Var *) linitial(opexpr->args);
+	right_var = (Var *) lsecond(opexpr->args);
+
+	/* Extract join columns */
+	if (left_var->varno == 1 && right_var->varno == 2)
+	{
+		left_attnum = left_var->varattno;
+		right_attnum = right_var->varattno;
+	}
+	else if (left_var->varno == 2 && right_var->varno == 1)
+	{
+		left_attnum = right_var->varattno;
+		right_attnum = left_var->varattno;
+	}
+	else
+	{
+		/* Unexpected varno values */
+		return false;
+	}
+
+	/*
+	 * Now assign primary vs other based on which table has the statistics
+	 * columns. Currently, statistics columns must be on the "other" table
+	 * (specified by stxkeys_varno), not the primary table. The primary table
+	 * is the estimation target.
+	 *
+	 * Populate jk_attnums as: [primary_attnum, other_attnum]
+	 */
+	if (stxkeys_varno == 1)
+	{
+		/* Left table has statistics columns, so it's the other table */
+		*other_relid = left_relid;
+		*relid = right_relid;
+		jk_attnums[0] = right_attnum;	/* primary table join column */
+		jk_attnums[1] = left_attnum;	/* other table join column */
+	}
+	else if (stxkeys_varno == 2)
+	{
+		/* Right table has statistics columns, so it's the other table */
+		*other_relid = right_relid;
+		*relid = left_relid;
+		jk_attnums[0] = left_attnum;	/* primary table join column */
+		jk_attnums[1] = right_attnum;	/* other table join column */
+	}
+	else
+	{
+		/* Invalid stxkeys_varno */
+		return false;
+	}
+
+	return true;
+}
+
 /*
  * StatisticsGetRelation: given a statistics object's OID, get the OID of
  * the relation it is defined on.  Uses the system cache.
diff --git a/src/backend/optimizer/path/clausesel.c b/src/backend/optimizer/path/clausesel.c
index 25c4d177ad9..91630df6b1a 100644
--- a/src/backend/optimizer/path/clausesel.c
+++ b/src/backend/optimizer/path/clausesel.c
@@ -129,19 +129,44 @@ clauselist_selectivity_ext(PlannerInfo *root,
 	int			listidx;
 
 	/*
-	 * If there's exactly one clause, just go directly to
-	 * clause_selectivity_ext(). None of what we might do below is relevant.
+	 * Determine if these clauses reference a single relation.
 	 */
-	if (list_length(clauses) == 1)
+	rel = find_single_rel_for_clauses(root, clauses);
+
+	/*
+	 * If there's exactly one clause that references a single relation, just
+	 * go directly to clause_selectivity_ext(). None of what we might do below
+	 * is relevant. If multiple relations are referenced, we must NOT
+	 * short-circuit because we need to detect join stats opportunities.
+	 */
+	if (list_length(clauses) == 1 && rel != NULL)
 		return clause_selectivity_ext(root, (Node *) linitial(clauses),
 									  varRelid, jointype, sjinfo,
 									  use_extended_stats);
 
 	/*
-	 * Determine if these clauses reference a single relation.  If so, and if
-	 * it has extended statistics, try to apply those.
+	 * Try applying extended statistics for joins/parameterized scans.
+	 *
+	 * Note: FK-based joins are already handled by
+	 * get_foreign_key_join_selectivity() which runs before
+	 * clauselist_selectivity(). This primarily benefits: - Parameterized path
+	 * estimation (before FK selectivity runs) - Non-FK join path estimation
+	 */
+	if (use_extended_stats && !rel)
+	{
+		/*
+		 * Estimate as many clauses as possible using extended statistics.
+		 *
+		 * 'estimatedclauses' is populated with the 0-based list position
+		 * index of clauses estimated here, and that should be ignored below.
+		 */
+		s1 *= statext_join_mcv_clauselist_selectivity(root, clauses, varRelid,
+													  &estimatedclauses);
+	}
+
+	/*
+	 * Try applying extended statistics for single table scans.
 	 */
-	rel = find_single_rel_for_clauses(root, clauses);
 	if (use_extended_stats && rel && rel->rtekind == RTE_RELATION && rel->statlist != NIL)
 	{
 		/*
@@ -150,9 +175,9 @@ clauselist_selectivity_ext(PlannerInfo *root,
 		 * 'estimatedclauses' is populated with the 0-based list position
 		 * index of clauses estimated here, and that should be ignored below.
 		 */
-		s1 = statext_clauselist_selectivity(root, clauses, varRelid,
-											jointype, sjinfo, rel,
-											&estimatedclauses, false);
+		s1 *= statext_clauselist_selectivity(root, clauses, varRelid,
+											 jointype, sjinfo, rel,
+											 &estimatedclauses, false);
 	}
 
 	/*
diff --git a/src/backend/optimizer/path/costsize.c b/src/backend/optimizer/path/costsize.c
index 16bf1f61a0f..0b1281d43e1 100644
--- a/src/backend/optimizer/path/costsize.c
+++ b/src/backend/optimizer/path/costsize.c
@@ -108,6 +108,7 @@
 #include "utils/selfuncs.h"
 #include "utils/spccache.h"
 #include "utils/tuplesort.h"
+#include "statistics/statistics.h"
 
 
 #define LOG2(x)  (log(x) / 0.693147180559945)
@@ -5692,6 +5693,10 @@ get_foreign_key_join_selectivity(PlannerInfo *root,
 		bool		ref_is_outer;
 		List	   *removedlist;
 		ListCell   *cell;
+		Selectivity join_mcv_sel = 0.0;
+		RelOptInfo *con_rel;
+		RelOptInfo *ref_rel;
+		JoinMCVOpportunity *join_opp;
 
 		/*
 		 * This FK is not relevant unless it connects a baserel on one side of
@@ -5821,6 +5826,10 @@ get_foreign_key_join_selectivity(PlannerInfo *root,
 		 * knowledge that each referencing row will match exactly one row in
 		 * the referenced table.
 		 *
+		 * ENHANCED: First check if extended join MCV statistics exist for
+		 * this FK. If so, use the more accurate MCV-based selectivity instead
+		 * of the FK heuristic (1.0 / ref_tuples).
+		 *
 		 * XXX that's not true in the presence of nulls in the referencing
 		 * column(s), so in principle we should derate the estimate for those.
 		 * However (1) if there are any strict restriction clauses for the
@@ -5839,6 +5848,36 @@ get_foreign_key_join_selectivity(PlannerInfo *root,
 		 * work, it is uncommon in practice to have an FK referencing a parent
 		 * table.  So, at least for now, disregard inheritance here.
 		 */
+		con_rel = find_base_rel(root, fkinfo->con_relid);
+		ref_rel = find_base_rel(root, fkinfo->ref_relid);
+
+		/* Try to detect join MCV opportunity */
+		join_opp = find_join_mcv_opportunity(root,
+											 ref_is_outer ? ref_rel : con_rel,
+											 ref_is_outer ? con_rel : ref_rel,
+											 *restrictlist);
+		if (join_opp)
+		{
+			JoinMCVList *join_mcv;
+
+			join_mcv = statext_join_mcv_load(join_opp->target_rel,
+											 join_opp->target_joinkey,
+											 join_opp->other_rel,
+											 join_opp->other_joinkey,
+											 join_opp->filter_attnums);
+			if (join_mcv)
+			{
+				join_mcv_sel = join_mcv_clauselist_selectivity(join_mcv,
+															   join_opp->filter_values,
+															   join_opp->filter_attnums,
+															   join_opp->collation);
+				pfree(join_mcv);
+
+				ereport(DEBUG1,
+						(errmsg("  FK: extended join MCV found, selectivity = %.6f", join_mcv_sel)));
+			}
+		}
+
 		if (jointype == JOIN_SEMI || jointype == JOIN_ANTI)
 		{
 			/*
@@ -5852,11 +5891,26 @@ get_foreign_key_join_selectivity(PlannerInfo *root,
 			 * restriction clauses, which is rows / tuples; but we must guard
 			 * against tuples == 0.
 			 */
-			RelOptInfo *ref_rel = find_base_rel(root, fkinfo->ref_relid);
 			double		ref_tuples = Max(ref_rel->tuples, 1.0);
 
 			fkselec *= ref_rel->rows / ref_tuples;
 		}
+		else if (join_mcv_sel > 0)
+		{
+			/*
+			 * Apply extended join MCV selectivity.
+			 *
+			 * For IN clauses: join_mcv_sel = average selectivity per filter
+			 * constant For equality:   join_mcv_sel = selectivity for that
+			 * single constant Using the average ensures multiplying by
+			 * inner_rows recovers the correct total selectivity.
+			 */
+			fkselec *= join_mcv_sel;
+
+			ereport(DEBUG1,
+					(errmsg("  FK APPLIED (MCV): selectivity = %.6f, cumulative fkselec = %.6f",
+							join_mcv_sel, fkselec)));
+		}
 		else
 		{
 			/*
@@ -5864,7 +5918,6 @@ get_foreign_key_join_selectivity(PlannerInfo *root,
 			 * guard against tuples == 0.  Note we should use the raw table
 			 * tuple count, not any estimate of its filtered or joined size.
 			 */
-			RelOptInfo *ref_rel = find_base_rel(root, fkinfo->ref_relid);
 			double		ref_tuples = Max(ref_rel->tuples, 1.0);
 
 			fkselec *= 1.0 / ref_tuples;
diff --git a/src/backend/parser/gram.y b/src/backend/parser/gram.y
index 713ee5c10a2..2bccc1147b1 100644
--- a/src/backend/parser/gram.y
+++ b/src/backend/parser/gram.y
@@ -4867,6 +4867,13 @@ stats_param:	ColId
 					$$->name = $1;
 					$$->expr = NULL;
 				}
+			| ColId indirection
+				{
+					/* Table-qualified column reference (e.g., tbl.col) */
+					$$ = makeNode(StatsElem);
+					$$->name = NULL;
+					$$->expr = (Node *) makeColumnRef($1, $2, @1, yyscanner);
+				}
 			| func_expr_windowless
 				{
 					$$ = makeNode(StatsElem);
